
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Event_streamsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const event_streams = await db.event_streams.create(
            {
                id: data.id || undefined,
        
        stream_type: data.stream_type
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        subject_or_topic: data.subject_or_topic
        ||
        null
            ,
            
        retention_policy: data.retention_policy
        ||
        null
            ,
            
        retention_days: data.retention_days
        ||
        null
            ,
            
        stream_status: data.stream_status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await event_streams.setTenant( data.tenant || null, {
            transaction,
        });
        
        await event_streams.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return event_streams;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const event_streamsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                stream_type: item.stream_type
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                subject_or_topic: item.subject_or_topic
            ||
            null
            ,
            
                retention_policy: item.retention_policy
            ||
            null
            ,
            
                retention_days: item.retention_days
            ||
            null
            ,
            
                stream_status: item.stream_status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const event_streams = await db.event_streams.bulkCreate(event_streamsData, { transaction });

        // For each item created, replace relation files
        

        return event_streams;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const event_streams = await db.event_streams.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.stream_type !== undefined) updatePayload.stream_type = data.stream_type;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.subject_or_topic !== undefined) updatePayload.subject_or_topic = data.subject_or_topic;
        
        
        if (data.retention_policy !== undefined) updatePayload.retention_policy = data.retention_policy;
        
        
        if (data.retention_days !== undefined) updatePayload.retention_days = data.retention_days;
        
        
        if (data.stream_status !== undefined) updatePayload.stream_status = data.stream_status;
        
        
        updatePayload.updatedById = currentUser.id;

        await event_streams.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await event_streams.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await event_streams.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return event_streams;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const event_streams = await db.event_streams.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of event_streams) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of event_streams) {
                await record.destroy({transaction});
            }
        });


        return event_streams;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const event_streams = await db.event_streams.findByPk(id, options);

        await event_streams.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await event_streams.destroy({
            transaction
        });

        return event_streams;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const event_streams = await db.event_streams.findOne(
            { where },
            { transaction },
        );

        if (!event_streams) {
            return event_streams;
        }

        const output = event_streams.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.conference_events_event_stream = await event_streams.getConference_events_event_stream({
            transaction
        });
        
        
        
        output.tenant = await event_streams.getTenant({
            transaction
        });
        
        
        output.organizations = await event_streams.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'event_streams',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.subject_or_topic) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'event_streams',
                        'subject_or_topic',
                        filter.subject_or_topic,
                    ),
                };
            }
            

            
            

            
            if (filter.retention_daysRange) {
                const [start, end] = filter.retention_daysRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    retention_days: {
                    ...where.retention_days,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    retention_days: {
                    ...where.retention_days,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.stream_type) {
                where = {
                    ...where,
                stream_type: filter.stream_type,
            };
            }
            
            if (filter.retention_policy) {
                where = {
                    ...where,
                retention_policy: filter.retention_policy,
            };
            }
            
            if (filter.stream_status) {
                where = {
                    ...where,
                stream_status: filter.stream_status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.event_streams.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'event_streams',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.event_streams.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

